/*************************************************************
 * Author:    wangjiangyuan (wangjiangyuan@agora.io)
 * Date  :    Oct 21th, 2020
 * Module:    Agora SD-RTN SDK RTC C API demo application.
 *
 *
 * This is a part of the Agora RTC Service SDK.
 * Copyright (C) 2020 Agora IO
 * All rights reserved.
 *
 *************************************************************/

#ifndef __MEDIA_PARSER_H__
#define __MEDIA_PARSER_H__

#include <stdlib.h>
#include <stdint.h>

typedef struct {
	union {
		struct {
			int32_t sampleRateHz;
			int32_t numberOfChannels;
		} audio_cfg;
	} u;
} parser_cfg_t;

typedef struct {
	int32_t type;
	uint8_t *ptr;
	uint32_t len;

	union {
		struct {
			uint32_t key_frame_flag;
		} video;

		struct {
			int32_t sampleRateHz;
			int32_t samplesPerChannel;
			int32_t numberOfChannels;
		} audio;
	} u;
} frame_t;

void *create_file_parser(int32_t codec, const char *path, parser_cfg_t *p_parser_cfg);
int32_t file_parser_obtain_frame(void *p_parser, frame_t *p_frame);
void destroy_file_parser(void *p_parser);

#endif /* __MEDIA_PARSER_H__ */